"
 COPYRIGHT (c) 1993 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

OrderedCollection subclass:#ChangeSet
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'System-Changes'
!

!ChangeSet  class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1993 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    used in the changes management to keep track of changes

    [author:]
        Claus Gittinger
"
! !

!ChangeSet  class methodsFor:'queries'!

current
    "ST-80 compatibility: return the current changeSet"

    |p|

    (Project notNil and:[(p := Project current) notNil]) ifTrue:[
	^ p changeSet
    ]

    "
     ChangeSet current 
    "
! !

!ChangeSet methodsFor:'change management'!

addClassCategoryChange:newCategory for:aClass
    "add a classCategory change to the receiver"

    |newChange|

    newChange := ClassCategoryChange class:aClass category:newCategory.
    self add:newChange

    "Created: 3.12.1995 / 13:45:53 / cg"
    "Modified: 15.7.1996 / 09:26:52 / cg"
!

addClassDefinitionChangeFor:aClass
    "add a classDefinition change to the receiver"

    |newChange|

    newChange := ClassDefinitionChange class:aClass.
    self add:newChange

    "Modified: 15.7.1996 / 09:27:05 / cg"
!

addMethodCategoryChange:aMethod category:newCategory in:aClass
    "add a methodCategory change to the receiver"

    |newChange|

    newChange := MethodCategoryChange class:aClass
                                   selector:(aClass selectorAtMethod:aMethod)
                                   category:newCategory.
    self add:newChange

    "Modified: 15.7.1996 / 09:27:15 / cg"
!

addMethodChange:aMethod in:aClass
    "add a method change to the receiver"

    |newChange|

    newChange := MethodChange class:aClass
                           selector:(aClass selectorAtMethod:aMethod)
                             source:aMethod source
                           category:aMethod category.
    self add:newChange

    "Modified: 15.7.1996 / 09:27:21 / cg"
!

addMethodPrivacyChange:aMethod in:aClass
    "add a methodPrivacy change to the receiver"

    |newChange|

    newChange := MethodPrivacyChange class:aClass
                                   selector:(aClass selectorAtMethod:aMethod)
                                   privacy:aMethod privacy.
    self add:newChange

    "Modified: 27.8.1995 / 22:55:22 / claus"
    "Modified: 15.7.1996 / 09:27:28 / cg"
!

addPrimitiveDefinitionsChangeFor:aClass
    "add a primitiveDefinitions change to the receiver"

    |newChange|

    newChange := ClassPrimitiveDefinitionsChange class:aClass.
    self add:newChange

    "Modified: 15.7.1996 / 09:27:40 / cg"
!

addPrimitiveFunctionsChangeFor:aClass
    "add a primitiveFunctions change to the receiver"

    |newChange|

    newChange := ClassPrimitiveFunctionsChange class:aClass.
    self add:newChange

    "Modified: 15.7.1996 / 09:27:47 / cg"
!

addPrimitiveVariablesChangeFor:aClass
    "add a primitiveVariables change to the receiver"

    |newChange|

    newChange := ClassPrimitiveVariablesChange class:aClass.
    self add:newChange

    "Modified: 15.7.1996 / 09:27:55 / cg"
! !

!ChangeSet methodsFor:'misc'!

addPatch:nameOfPatch
    "ignored for now - allows fileIn of ST-80 patch stuff .."

    ^ self
! !

!ChangeSet  class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic3/ChangeSet.st,v 1.18 1996-07-15 07:30:33 cg Exp $'
! !
