"
 COPYRIGHT (c) 1995 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

AbstractSourceCodeManager subclass:#RCSSourceCodeManager
	instanceVariableNames:''
	classVariableNames:'Verbose RCSRoot'
	poolDictionaries:''
	category:'System-SourceCodeManagement'
!

!RCSSourceCodeManager class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1995 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    WARNING:
        this class is incomplete and provided as a sceletton
        if CVS is not to be used as a SourceCodeManager.
        We highly recommend to use CVS.

    SourceCodeManager which accesses sourcecode through RCS.
    It requires the shell environment variable RCSROOT to be set
    to the top of a source tree, in which each subdirectory contains an RCS directory
    containing the source repositories.
    This is similar to the old ST/X source code setup and commonly used in
    development. However, ST/X is now maintained using CVS; therefore, consider this
    implementation as a hint and example how RCS management could be used with ST/X.
    This is an untested example; NO WARRANTY whatsoever.

    Read the comment in CVSSourceCodeManager on how source information is extracted
    from a classes packageString.
    RCSManager does not support modules - all sources are expected to be found
    under a common RCSROOT directory.
    You may have to adapt the code for your particular requirements.
    to be able to retrieve a classes source.
"
! !

!RCSSourceCodeManager class methodsFor:'initialization'!

initialize
    "/
    "/ if RCSROOT is non-empty and co is available
    "/ as commands, assume this system uses an RCS source code management.
    "/
    (RCSRoot := OperatingSystem getEnvironment:'RCSROOT') notNil ifTrue:[
	(OperatingSystem canExecuteCommand:'co') ifTrue:[
	    self initCacheDirPath.
	    Smalltalk at:#SourceCodeManager put:self.
	    'RCS SourceCodeManager installed.' infoPrintNL.
	]
    ]

    "
     RCSSourceCodeManager initialize
    "

    "Created: 4.11.1995 / 19:14:38 / cg"
! !

!RCSSourceCodeManager class methodsFor:'source code access'!

streamForClass:cls fileName:classFileName revision:revision directory:packageDir module:moduleDir cache:cacheIt
    "extract a source file and return an open readStream on it."

    |dir cachedSourceFilename temporaryFile file cmd fullName stream revisionArg|

    RCSRoot isNil ifTrue:[
	'RCSMGR: RCSROOT not set' infoPrintNL.
	^ nil
    ].

    "/ if not already existing, create a temp directory
    "/ where we deposit sources.
    "/ this is used as a cache for fursther requests, since
    "/ accessing the repository may be slow.
    "/ (if cvs uses a remote connection via ppp, for example)
    "/

    (dir := self sourceCacheDirectory) isNil ifTrue:[
	^ nil
    ].

    fullName := packageDir , '/RCS/' , classFileName , '.st'.

    (revision isNil or:[revision == #newest]) ifTrue:[
	cachedSourceFilename := classFileName.
    ] ifFalse:[
	cachedSourceFilename := classFileName , '_' , revision.
    ].

    file := (dir construct:cachedSourceFilename) asFilename.
    file exists ifTrue:[
"/        ('RCSMGR: found existing: ', file name) infoPrintNL.
    ] ifFalse:[
	"/
	"/ ok, ask co to extract the corresponding source code
	"/ into the cache directory ...
	"/
	temporaryFile := (Filename newTemporaryIn:nil) name.
	(revision isNil or:[revision == #newest]) ifTrue:[
	    revisionArg := ''
	] ifFalse:[
	    revisionArg := '-r' , revision
	].

	cmd := '(cd ' , CacheDirectoryName , '; co -q ' , revisionArg , ' -p ' , RCSRoot , '/' , fullName , ' > ' , temporaryFile , ')'.
	Verbose == true ifTrue:[
	    ('RCSMGR: executing: ' , cmd ) infoPrintNL.
	].

	(OperatingSystem executeCommand:cmd) ifFalse:[
	    'RCSMGR: checkout failed' infoPrintNL.
	    ^ nil
	].

	cacheIt ifTrue:[
	    (OperatingSystem renameFile:(CacheDirectoryName , '/' , temporaryFile)
			    to:(CacheDirectoryName , '/' , cachedSourceFilename)) ifFalse:[
		('RCSMGR: failed to rename ', temporaryFile, ' to ', cachedSourceFilename) infoPrintNL.
		^ nil
	    ].
	] ifFalse:[
	    stream := (CacheDirectoryName , '/' , temporaryFile) asFilename readStream.
	    OperatingSystem removeFile:(CacheDirectoryName , '/' , temporaryFile).
	    ^ stream
	]
    ].
    ^ file readStream
! !

!RCSSourceCodeManager class methodsFor:'source code administration'!

revisionInfoFromString:aString
    "{ Pragma: +optSpace }"

    "return a dictionary filled with revision info.
     This extracts the relevant info from aString."

    ^ self revisionInfoFromRCSString:aString

    "Created: 29.1.1997 / 19:00:57 / cg"
! !

!RCSSourceCodeManager class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic3/Attic/RCSSourceCodeManager.st,v 1.11 1997-01-29 18:31:22 cg Exp $ [c]'
! !
RCSSourceCodeManager initialize!
